
SCREENHEIGHT = Turbine.UI.Display.GetHeight();
SCREENWIDTH = Turbine.UI.Display.GetWidth();
NUMGRADIENTS = 2;
gblMINWINLEFT = 0;
gblMINWINTOP = 0;
gblMINWINWIDTH = 400;
gblHEXCOLOR = 0;

-- WINDOW ELEMENTS -----------------------------------------------------------

-- Draw main window ----------------------------------------------------------

iParentWidth = 500;
iParentHeight = 475;
iParentLeft = ((SCREENWIDTH/2)-(iParentWidth/2));
iParentTop = ((SCREENHEIGHT/3)-(iParentHeight/2));

wParentWin = Turbine.UI.Lotro.Window()
wParentWin:SetSize(iParentWidth,iParentHeight);
wParentWin:SetPosition(iParentLeft,iParentTop);
wParentWin:SetText("ChatEdit");
wParentWin:SetVisible(true);

wMainWinBack = Turbine.UI.Control();
wMainWinBack:SetParent(wParentWin);
wMainWinBack:SetSize(498,471);
wMainWinBack:SetPosition(1,1);
wMainWinBack:SetBackground("GaluhadPlugins/ChatEdit/resources/MainWin_Back.tga");
wMainWinBack:SetBlendMode(4);
wMainWinBack:SetMouseVisible(false);


-- Min button ------------------------------------------------------------------
btnMin = Turbine.UI.Control();
btnMin:SetParent(wParentWin);
btnMin:SetSize(24,18);
btnMin:SetPosition(iParentWidth-64,(iParentHeight-35));
btnMin:SetZOrder(5);
btnMin:SetBackground("GaluhadPlugins/ChatEdit/resources/min_up.jpg");

-- Remove formatting button ------------------------------------------------------------------
btnDeformat = Turbine.UI.Lotro.Button();
btnDeformat:SetParent(wParentWin);
btnDeformat:SetWidth(160);
btnDeformat:SetPosition(40,(iParentHeight-35));
btnDeformat:SetText("Remove Formatting");

btnDeformat.Click = function()

	if _MARKUP ~= nil then
		for k,v in pairs(_MARKUP) do
			v.COLOR = 0;
		end
	end

	RefreshString();
	AliasUpdate();
end

-- open button -----------------------------------------------------------------

bOpen = Turbine.UI.Window();
bOpen:SetSize(23,23);
bOpen:SetBackground("GaluhadPlugins/ChatEdit/resources/open.jpg");
bOpen:SetPosition(20,(SCREENHEIGHT - 40));
bOpen:SetVisible(true);

-- Draw input text box -------------------------------------------------------
txtWin = Turbine.UI.Control();
txtWin:SetParent(wParentWin);
txtWin:SetSize(iParentWidth-50,60);
txtWin:SetPosition(25,260);
txtWin:SetBackColor(Turbine.UI.Color(1,1,1));

txtInput = Turbine.UI.TextBox();
txtInput:SetParent(txtWin);
txtInput:SetSize((txtWin:GetWidth() - 10), (txtWin:GetHeight() - 10));
txtInput:SetPosition(((txtWin:GetWidth()/2) - (txtInput:GetWidth()/2)), ((txtWin:GetHeight()/2) - (txtInput:GetHeight()/2)));
txtInput:SetMultiline(true);
txtInput:SetMarkupEnabled(false);
txtInput:SetBackColor(Turbine.UI.Color(1,1,1,1));
txtInput:SetFont(Turbine.UI.Lotro.Font.Verdana14);
txtInput:SetForeColor(Turbine.UI.Color(0,0,0));
txtInput:SetSelectable(true);
txtInput:SetEnabled(true);
txtInput:SetVisible(true);

-- Check if any text is selected, if so then apply the new colour to that part.

txtInput.MouseLeave = function ()

	local selLength = txtInput:GetSelectionLength();

	if selLength > 0 then -- text is highlighted

		local selText = txtInput:GetSelectedText();
		local selStart = txtInput:GetSelectionStart();
		local selEnd = selStart + (selLength-1);

		_SELECTION = {["START"] = selStart; ["END"] = selEnd; ["TEXT"] = selText;};

	else

		_SELECTION = nil;

	end

end

buttonTop = txtWin:GetTop() + txtWin:GetHeight() + 10;



txtOutWin = Turbine.UI.Control();
txtOutWin:SetParent(wParentWin);
txtOutWin:SetSize(iParentWidth-50,60);
txtOutWin:SetPosition(25,370);
txtOutWin:SetBackColor(Turbine.UI.Color(0.5,0,0,0));

txtOutput = Turbine.UI.TextBox();
txtOutput:SetParent(txtOutWin);
txtOutput:SetSize((txtWin:GetWidth() - 10), (txtWin:GetHeight() - 10));
txtOutput:SetPosition(((txtWin:GetWidth()/2) - (txtInput:GetWidth()/2)), ((txtWin:GetHeight()/2) - (txtInput:GetHeight()/2)));
txtOutput:SetMultiline(true);
txtOutput:SetMarkupEnabled(true);
--txtOutput:SetBackColor(Turbine.UI.Color(1,1,1,1));
txtOutput:SetFont(Turbine.UI.Lotro.Font.Verdana14);
txtOutput:SetForeColor(Turbine.UI.Color(1,1,1));
txtOutput:SetSelectable(false);
txtOutput:SetEnabled(false);
txtOutput:SetVisible(true);
txtOutput:SetOutlineColor(Turbine.UI.Color(0.1,0.1,0.1));
txtOutput:SetFontStyle(Turbine.UI.FontStyle.Outline);
txtOutput:SetText("- Output preview -");


-- Input for tells ------------------------------------------------------------
txtTell = Turbine.UI.TextBox();
txtTell:SetParent(wParentWin);
txtTell:SetSize(110,20);
txtTell:SetPosition(((txtWin:GetLeft() + txtWin:GetWidth())-txtTell:GetWidth()),(txtWin:GetTop()-30));
txtTell:SetBackColor(Turbine.UI.Color(1,1,1,1));
txtTell:SetForeColor(Turbine.UI.Color(0,0,0));
txtTell:SetSelectable(true);
txtTell:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
txtTell:SetVisible(false);
txtTell:SetMultiline(false);


-- Draw Buttons ------------------------------------------------------------------

-- SEND BUTTON ------------------------------------------------------------------

-- Create quickslot to store shortcut-----------------------------------------------
qsTemp = Turbine.UI.Lotro.Quickslot();
qsTemp:SetParent(wParentWin);
qsTemp:SetSize(96,18);
qsTemp:SetPosition((txtWin:GetLeft()+txtWin:GetWidth()-96),buttonTop+2);
qsTemp:SetZOrder(1);
qsTemp:SetVisible(true);

btnSend = Turbine.UI.Window();
btnSend:SetParent(wParentWin);
btnSend:SetSize(96,18);
btnSend:SetPosition((txtWin:GetLeft()+txtWin:GetWidth()-96),buttonTop+2);
btnSend:SetBackground("GaluhadPlugins/ChatEdit/resources/send_up.jpg");
btnSend:SetVisible(true);
btnSend:SetZOrder(50);
btnSend:SetMouseVisible(false);

btnGradient = Turbine.UI.Lotro.Button();
btnGradient:SetParent(wParentWin);
btnGradient:SetSize(100,30);
btnGradient:SetText("Gradient");
btnGradient:SetPosition(btnSend:GetLeft(),42);
btnGradient:SetVisible(true);


-- Save alias button ------------------------------------------------------------
btnSave = Turbine.UI.Lotro.Button();
btnSave:SetParent(wParentWin);
btnSave:SetSize(96,18);
btnSave:SetPosition((btnSend:GetLeft() - 96 - 10),buttonTop+1);
btnSave:SetText("Save");
btnSave:SetVisible(true);
btnSave:SetEnabled(false);


btnTarget = Turbine.UI.Lotro.Button();
btnTarget:SetParent(wParentWin);
btnTarget:SetSize(96,18);
btnTarget:SetPosition((btnSave:GetLeft() - 96 - 10),buttonTop+1);
btnTarget:SetText(";target");
btnTarget:SetVisible(true);


-- Preview button --------------------------------------------------------------
--[[
btnPrev = Turbine.UI.Lotro.Button();
btnPrev:SetParent(wParentWin);
btnPrev:SetSize(96,18);
btnPrev:SetPosition((btnSave:GetLeft() - 96 - 10),buttonTop+1);
btnPrev:SetText("Preview");
btnPrev:SetVisible(true);
]]--


-- Draw Labels -----------------------------------------------------------------
lblInput = Turbine.UI.Label();
lblInput:SetParent(wParentWin);
lblInput:SetSize(150,15);
lblInput:SetPosition(txtWin:GetLeft(),(txtWin:GetTop() - lblInput:GetHeight() - 10));
lblInput:SetMarkupEnabled(true);
lblInput:SetText("Text to display:");
lblInput:SetForeColor(Turbine.UI.Color(1,1,1));

lblTell = Turbine.UI.Label();
lblTell:SetParent(wParentWin);
lblTell:SetSize(150,15);
lblTell:SetPosition((txtTell:GetLeft()-160),(txtWin:GetTop() - lblInput:GetHeight() - 10));
lblTell:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
lblTell:SetText("Player to /Tell:");
lblTell:SetForeColor(Turbine.UI.Color(1,1,1));
lblTell:SetVisible(false);


-- Draw drop-down for chat channels -----------------------------------------------
cSpeechIcon = Turbine.UI.Control();
cSpeechIcon:SetParent(wParentWin);
cSpeechIcon:SetSize(21,18);
cSpeechIcon:SetPosition(txtWin:GetLeft(), buttonTop);
cSpeechIcon:SetBackground("GaluhadPlugins/ChatEdit/resources/speechc.tga");
cSpeechIcon:SetBlendMode(5);

lblChannel = Turbine.UI.Label();
lblChannel:SetParent(wParentWin);
lblChannel:SetSize(80,18);
lblChannel:SetPosition((cSpeechIcon:GetLeft() + cSpeechIcon:GetWidth() + 4), cSpeechIcon:GetTop()-1);
lblChannel:SetForeColor(Turbine.UI.Color(0,0.8,0.8));
lblChannel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
lblChannel:SetFont(Turbine.UI.Lotro.Font.Verdana16);
lblChannel:SetText("Say");


-- Color Previews ----------------------------------------------------------------
wPrevBack = Turbine.UI.Window();
wPrevBack:SetParent(wParentWin);
wPrevBack:SetSize(25,25);
wPrevBack:SetPosition(txtWin:GetLeft(),40);
wPrevBack:SetBackColor(Turbine.UI.Color(1,1,1));
wPrevBack:SetVisible(true);

wPreview = Turbine.UI.Window();
wPreview:SetParent(wPrevBack);
wPreview:SetSize(wPrevBack:GetWidth() - 2, wPrevBack:GetHeight() - 2);
wPreview:SetPosition(1,1);
wPreview:SetBackColor(Turbine.UI.Color(0,0,0));
wPreview:SetVisible(true);

lblHEX = Turbine.UI.TextBox();
lblHEX:SetParent(wParentWin);
lblHEX:SetSize(65,18);
lblHEX:SetPosition((wPrevBack:GetLeft() + wPrevBack:GetWidth() + 10), 42);
lblHEX:SetForeColor(Turbine.UI.Color(0,0.8,0.8));
lblHEX:SetMultiline(false);
lblHEX:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
lblHEX:SetSelectable(true);
lblHEX:SetFont(Turbine.UI.Lotro.Font.Verdana16);
lblHEX:SetText("#000000");

-- Alias links -------------------------------------------------------------------
wAliasParent = Turbine.UI.Window();
wAliasParent:SetHeight(25);
wAliasParent:SetBackColor(Turbine.UI.Color(0.5,0.5,0));
wAliasParent:SetOpacity(0.4);
wAliasParent:SetWidth(0);
wAliasParent:SetVisible(false);

wAliasPreview = Turbine.UI.Window();
wAliasPreview:SetHeight(20);
wAliasPreview:SetBackColor(Turbine.UI.Color(0,0,0));
wAliasPreview:SetVisible(false);

lAliasPreview = Turbine.UI.TextBox();
lAliasPreview:SetParent(wAliasPreview);
lAliasPreview:SetSize(wAliasPreview:GetWidth() - 10, wAliasPreview:GetHeight()-8);
lAliasPreview:SetPosition(5,4);
lAliasPreview:SetMarkupEnabled(true);
lAliasPreview:SetForeColor(Turbine.UI.Color(1,1,1));
lAliasPreview:SetBackColor(Turbine.UI.Color(0,0,0));
lAliasPreview:SetVisible(true);
lAliasPreview:SetMultiline(false);


-- Create the color picker --------------------------------------------------------
myPicker = ColorPicker.ColorPicker.Create();
myPicker:SetParent(wParentWin);
myPicker:SetPosition(txtWin:GetLeft(),70);
myPicker:SetSize(450,70);
--myPicker:Draw();

myPicker.LeftClick = function ()
	local RGB = myPicker:GetRGBColor();
	SetColor((RGB.R/255),(RGB.G/255),(RGB.B/255));
end
